## mender-flash 1.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

# fail hard when some include doesn't 100% work
if (POLICY CMP0111)
  cmake_policy(SET CMP0111 NEW)
endif (POLICY CMP0111)

# update timestamps of downloaded files after extraction instead of keeping the timestamps from the archive
if (POLICY CMP0135)
  cmake_policy(SET CMP0135 NEW)
endif (POLICY CMP0135)

project(mender-flash)

option(BUILD_TESTS "Build the unit tests (Default: ON)" ON)
# set(CMAKE_VERBOSE_MAKEFILE ON)

# TODO: proper platform detection
set(PLATFORM linux_x86)

#---------------------------------------------------------------------------------------------------
# When deciding which one(s) of these to include, the general rule is this:
#
# If it's a cross platform component, add this:
#   target_link_libraries(<TARGET> PUBLIC crossplatform_compiler_flags)
#
# If it's a platform specific component, with a cross platform interface, add this:
#   target_link_libraries(<TARGET> PRIVATE platform_compiler_flags)
#   target_link_libraries(<TARGET> INTERFACE crossplatform_compiler_flags)

add_library(crossplatform_compiler_flags INTERFACE)
target_compile_features(crossplatform_compiler_flags INTERFACE cxx_std_11)
target_compile_options(crossplatform_compiler_flags INTERFACE -std=c++11 -Werror -Wall -Wconversion)

# use the 64bit variants of filesystem functions consistently. improves
# compatibility with musl, which only exposes the 64bit variants, but without
# the name suffix.
target_compile_definitions(crossplatform_compiler_flags INTERFACE _FILE_OFFSET_BITS=64)

add_library(platform_compiler_flags INTERFACE)
target_compile_features(platform_compiler_flags INTERFACE cxx_std_17)
target_compile_options(platform_compiler_flags INTERFACE -std=c++17 -Werror -Wall -Wconversion)
#---------------------------------------------------------------------------------------------------

add_executable(mender-flash "main.cpp")
install(TARGETS mender-flash
  DESTINATION bin
  COMPONENT mender-flash
)
target_include_directories(mender-flash PUBLIC .)
target_link_libraries(mender-flash flashlib)


# CMake doesn't generate the 'uninstall' target.
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

add_custom_target(install-bin
  COMMAND ${CMAKE_COMMAND} --install . --component=mender-flash
)
add_custom_target(uninstall-bin
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_COMPONENT=mender-flash -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

# Find all the source files in the flash and common directories
set(FLASH_SOURCES "libflash/fileio.cpp" "libflash/optimized_writer.cpp" "libflash/platformfs.cpp")
set(COMMON_SOURCES "common/io.cpp" "common/io.cpp" "common/error.cpp" "common/io.cpp" "common/common.cpp")


# Combine the source files from both directories into one list
set(LIB_SOURCES ${FLASH_SOURCES} ${COMMON_SOURCES})

# Create a static library from the combined source files
add_library(flashlib STATIC ${LIB_SOURCES})
target_include_directories(flashlib PUBLIC ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/libflash ${CMAKE_SOURCE_DIR}/vendor/expected/include)
target_link_libraries(flashlib PUBLIC crossplatform_compiler_flags)

if(BUILD_TESTS)
  add_subdirectory(tests)
endif()

=== debian/changelog ===
mender-flash (1.0.2-1+ubuntu+noble) stable; urgency=medium

  * Release 1.0.2-1+ubuntu+noble. See online docs for complete changelog

 -- root <root@091ae42699aa>  Tue, 09 Sep 2025 11:52:48 +0000

## mender-flash 1.1.0~git20250717.e342b2b

=== debian/changelog ===
mender-flash (1.1.0~git20250717.e342b2b-2+ubuntu+noble+builder2092099627) experimental; urgency=medium

  * Release 1.1.0~git20250717.e342b2b-2+ubuntu+noble+builder2092099627.
    See online docs for complete changelog

 -- root <root@60898841c5bd>  Fri, 10 Oct 2025 07:48:08 +0000

## mender-flash 1.1.0~git20251015.cb94ba4

=== debian/changelog ===
mender-flash (1.1.0~git20251015.cb94ba4-1+ubuntu+noble+builder2101868185) experimental; urgency=medium

  * Release 1.1.0~git20251015.cb94ba4-1+ubuntu+noble+builder2101868185.
    See online docs for complete changelog

 -- root <root@733b3069ca0f>  Wed, 15 Oct 2025 20:19:46 +0000

## mender-flash 1.1.0~git20251016.d48f00e

=== debian/changelog ===
mender-flash (1.1.0~git20251016.d48f00e-1+ubuntu+noble+builder2134755934) experimental; urgency=medium

  * Release 1.1.0~git20251016.d48f00e-1+ubuntu+noble+builder2134755934.
    See online docs for complete changelog

 -- root <root@1b610b27fb46>  Sat, 01 Nov 2025 20:20:25 +0000

## mender-flash 1.1.0~git20251104.04daed0

=== debian/changelog ===
mender-flash (1.1.0~git20251104.04daed0-1+ubuntu+noble+builder2170695238) experimental; urgency=medium

  * Release 1.1.0~git20251104.04daed0-1+ubuntu+noble+builder2170695238.
    See online docs for complete changelog

 -- root <root@f8e369d9ca8c>  Thu, 20 Nov 2025 20:32:52 +0000

=== debian/control ===
Source: mender-flash
Maintainer: Mender Team <mender@northern.tech>
Section: admin
Priority: optional
Standards-Version: 4.0.0
Build-Depends-Indep: cmake, debhelper (>= 10)
Build-Depends: libstdc++-dev
Homepage: https://mender.io

Package: mender-flash
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Mender Flash is an utility to flash block devices used by the Mender Client
 to write into the inactive partition during a rootfs update.

## mender-flash 1.1.0~git20260105.57af6ee

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(mender-flash)

# set(CMAKE_VERBOSE_MAKEFILE ON)

option(COVERAGE "Turn coverage instrumentation on (Default: OFF)" OFF)
if($CACHE{COVERAGE})
  set(CMAKE_C_FLAGS "--coverage $CACHE{CMAKE_C_FLAGS}")
endif()

add_compile_options(-Wall -Wextra -Werror)
add_executable(mender-flash main.c)

install(TARGETS mender-flash
  DESTINATION bin
  COMPONENT mender-flash
)

enable_testing()
add_test(NAME tests
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/tests.sh" "${CMAKE_CURRENT_BINARY_DIR}"
)
add_custom_target(check
  COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
  DEPENDS mender-flash
)

if($CACHE{COVERAGE})
  add_custom_target(coverage_enabled COMMAND true)
else()
  add_custom_target(coverage_enabled
    COMMAND echo 'Please run `cmake -D COVERAGE=ON .` first!'
    COMMAND false
  )
endif()

add_custom_target(coverage
  COMMAND lcov --capture --quiet --directory .
               --output-file coverage.lcov
  DEPENDS coverage_enabled check
)

# CMake doesn't generate the 'uninstall' target.
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

add_custom_target(install-bin
  COMMAND ${CMAKE_COMMAND} --install . --component=mender-flash
)
add_custom_target(uninstall-bin
  COMMAND ${CMAKE_COMMAND} -D CMAKE_INSTALL_COMPONENT=mender-flash -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

=== debian/changelog ===
mender-flash (1.1.0~git20260105.57af6ee-1+ubuntu+noble+builder2325138823) experimental; urgency=medium

  * Release 1.1.0~git20260105.57af6ee-1+ubuntu+noble+builder2325138823.
    See online docs for complete changelog

 -- root <root@6fff41ff8c94>  Fri, 13 Feb 2026 20:20:01 +0000
